# Originally created by John Murga (cf. http://gcc.gnu.org/ml/java/2003-01/msg00299.html)
# Adapted by Mohan Embar (http://www.thisiscool.com/) for GCC 3.3
# Check that we appear to have set the environment up

. buildenv.sh

if [ ! $BUILD_ROOT_DIR  ]
then
    echo "You must set the enviroment before runing this script..."
    exit
fi

if [ ! -d $BUILD_ROOT_DIR  ]
then
    echo Setting up build directory...
    mkdir $BUILD_ROOT_DIR
    cd $BUILD_ROOT_DIR
fi

if [ ! -d $BU_SRC_DIR  ]
then
    echo Setting up binutils source directory...
    cd $BUILD_ROOT_DIR
    tar xfz $SUPP_SOURCES_DIR/$BUSRC_TAR_GZ
fi

# If we haven't even started the process we have to copy a few files into
# the destination directory of our new cross compiler.

if [ ! -d $XGCC_DIR ]
then
    echo Setting up cross-compiler build directory...

    mkdir $XGCC_DIR
    cd $XGCC_DIR
    mkdir mingw32
    cd mingw32

    tar xfz $SUPP_SOURCES_DIR/$MINGWRT_TAR_GZ
#   unzip $SUPP_SOURCES_DIR/mingw-runtime-2.4-scandir.zip
    tar xfz $SUPP_SOURCES_DIR/$W32API_TAR_GZ
fi

# The asumption being made with binutils is that you'll always be succesful,
# if you have any probs just delete $XBU_BUILD_DIR and it'll start from scratch

if [ ! -d $XBU_BUILD_DIR ]
then
    echo Setting up cross-binutils build directory...
    mkdir $XBU_BUILD_DIR
    cd $XBU_BUILD_DIR

    echo Configuring and building cross-binutils...
    sh $BUILD_SCRIPTS_DIR/cfgxbu.sh
    sh $BUILD_SCRIPTS_DIR/mkxbu.sh
fi

# If GCC isn't configured this make sure it is all set-up ready for a "make"

if [ ! -d $XGCC_BUILD_DIR ]
then
    echo Setting up cross-gcc build directory...
    mkdir $XGCC_BUILD_DIR
    cd $XGCC_BUILD_DIR
    sh $BUILD_SCRIPTS_DIR/cfgxgcc.sh
fi

# If all else has been done the only thing this script will do is attempt to
# make GCC, this way if you have applied any patches it'll incorporate them.

echo "About to build GCC... <<Press enter>>"
read dummyVar

cd $XGCC_BUILD_DIR
sh $BUILD_SCRIPTS_DIR/mkxgcc.sh

echo
echo "All done !"
